<template>
  <el-dialog
    :visible.sync="visible"
    width="80%"
    :title="!dataForm.id ? $t('add') : $t('update')"
    :close-on-click-modal="false"
    :close-on-press-escape="false"
  >
    <el-form
      :model="dataForm"
      :rules="dataRule"
      ref="dataForm"
      @keyup.enter.native="dataFormSubmitHandle()"
      :label-width="$i18n.locale === 'en-US' ? '120px' : '80px'"
    >
      <el-row :gutter="30">
        <el-col :span="12">
          <el-form-item
            label="受案号"
            prop="caseNum"
          >
            <el-input
              v-model="dataForm.caseNum"
              placeholder="受案号"
              readonly
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="案件名称"
            prop="caseName"
          >
            <el-input
              v-model="dataForm.caseName"
              placeholder="案件名称"
              readonly
            ></el-input>
          </el-form-item>
        </el-col>

      </el-row>
      <el-form-item
        label="办理期限"
        prop="deadline"
      >
        <el-input
          v-model="dataForm.deadline"
          placeholder="办理期限"
        ></el-input>
      </el-form-item>
      <el-row :gutter="30">
        <el-col :span="12">
          <el-form-item
            label="受理日期"
            prop="acceptanceDate"
          >
            <el-date-picker
              style="width:100%"
              v-model="dataForm.acceptanceDate"
              type="date"
              placeholder="受理日期"
            >
            </el-date-picker>

          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="审结日期"
            prop="completeDate"
          >
            <!-- <el-input
              v-model="dataForm.completeDate"
              placeholder="审结日期"
            ></el-input> -->
            <el-date-picker
              style="width:100%"
              v-model="dataForm.completeDate"
              type="date"
              placeholder="审结日期"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>
      <el-row :gutter="30">
        <el-col :span="12">
          <el-form-item
            label="强制措施"
            prop="coerciveMeasures"
          >
            <el-input
              v-model="dataForm.coerciveMeasures"
              placeholder="强制措施"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item
            label="案件比"
            prop="caseQuality"
          >
            <el-input
              v-model="dataForm.caseQuality"
              placeholder="案件比"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item
        label="案件详情"
        prop="caseDetail"
      >
        <el-input
          type="textarea"
          v-model="dataForm.caseDetail"
          placeholder="案件详情"
          rows="3"
        ></el-input>
      </el-form-item>
    </el-form>
    <template slot="footer">
      <el-button @click="visible = false">{{ $t('cancel') }}</el-button>
      <el-button
        type="primary"
        @click="dataFormSubmitHandle()"
      >{{ $t('confirm') }}</el-button>
    </template>
  </el-dialog>
</template>

<script>
import debounce from "lodash/debounce";
export default {
  data() {
    return {
      visible: false,
      dataForm: {
        id: "",
        caseNum: "",
        caseName: "",
        deadline: "",
        acceptanceDate: "",
        completeDate: "",
        coerciveMeasures: "",
        caseQuality: "",
        caseDetail: "",
        creator: "",
        createDate: "",
      },
    };
  },
  computed: {
    dataRule() {
      return {
        caseNum: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        caseName: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        deadline: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        acceptanceDate: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        completeDate: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        coerciveMeasures: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        caseQuality: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
        caseDetail: [
          {
            required: true,
            message: this.$t("validate.required"),
            trigger: "blur",
          },
        ],
      };
    },
  },
  methods: {
    init() {
      this.visible = true;
      this.$nextTick(() => {
        this.$refs["dataForm"].resetFields();
        if (this.dataForm.id) {
          this.getInfo();
        }
      });
    },
    // 获取信息
    getInfo() {
      this.$http
        .get(`/fhjw/fhjwcase/${this.dataForm.id}`)
        .then(({ data: res }) => {
          if (res.code !== 0) {
            return this.$message.error(res.msg);
          }
          this.dataForm = {
            ...this.dataForm,
            ...res.data,
          };
        })
        .catch(() => {});
    },
    // 表单提交
    dataFormSubmitHandle: debounce(
      function () {
        this.$refs["dataForm"].validate((valid) => {
          if (!valid) {
            return false;
          }
          this.$http[!this.dataForm.id ? "post" : "put"](
            "/fhjw/fhjwcase/",
            this.dataForm
          )
            .then(({ data: res }) => {
              if (res.code !== 0) {
                return this.$message.error(res.msg);
              }
              this.$message({
                message: this.$t("prompt.success"),
                type: "success",
                duration: 500,
                onClose: () => {
                  this.visible = false;
                  this.$emit("refreshDataList");
                },
              });
            })
            .catch(() => {});
        });
      },
      1000,
      { leading: true, trailing: false }
    ),
  },
};
</script>
